<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	MeS
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans MeS Payment Gateway
 *
 * @author Manisha Ranawat
 */
class plgPayplansMes extends XiPlugin
{
	public function onPayplansSystemStart()
	{
		$dir = dirname(__FILE__).DS.'mes'.DS.'app';
		PayplansHelperApp::addAppsPath($dir);
		
		return true;
	}

	public function onPayplansViewBeforeRender(XiView $view, $task)
    {
        //app will ask update credit card details at order confirm page only
        if($view instanceof PayplanssiteViewSubscription && ($task == 'display' || $task == 'getDetails'))
        {
		   $subscriptionId     	= $view->getModel()->getId();
		   $subscription       	= PayplansSubscription::getInstance($subscriptionId);
		   $orderId            	= $subscription->getOrder();
		   $order              	= PayplansOrder::getInstance($orderId);
		   $invoice            	= $order->getInvoice();
		   $invoiceId			= $invoice->getId();
            
	   	   $payment             = $invoice->getPayment();
		   if(!$payment){
		   	return true;
		   }
		   $appId              	= $payment->getApp();
		   $mesApp             	= PayplansHelperApp::getAvailableApps('mes');
		   $appIds             	= array();
		   foreach ($mesApp as $app) {
				 $appIds[]        = $app->getId();
		   }

			if($subscription->isRecurring() && in_array($appId, $appIds)){
				$this->_assign('invoice_id',    $invoiceId);
				return array('pp-subscription-display-action' => $this->_render('update_card'));
			}
        }
    }
	

	public function onPayplansUpdateCard()
	{
		$invoiceId	   = JFactory::getApplication()->input->get('invoice_id', false);
		
		$update 	   = new stdClass();
		$update->id    = 'payplans-update-card';
		$update->click = 'payplans.update.card('.$invoiceId.');';
		$update->text  = XiText::_('COM_PAYPLANS_APP_MES_UPDATE');
		$update->classes = "btn btn-primary";
		
		$close 		   = new stdClass();
		$close->id     = 'payplans-update-close';
		$close->click  = 'xi.ui.dialog.close();';
		$close->text   = XiText::_('COM_PAYPLANS_APP_MES_CLOSE');
		$close->classes = "btn";
		
		$html		 = $this->_render('update_form');	
        $title 		 = XiText::_('COM_PAYPLANS_APP_MES_UPDATE_CARD_DETAILS');
		$domObject   = 'xiWindowBody';
		$domProperty = 'innerHTML';

		$response = XiFactory::getAjaxResponse();
		$response->addAssign( $domObject , $domProperty , $html );
		$response->addScriptCall('xi.ui.dialog.title',$title);
		$response->addScriptCall('xi.ui.dialog.button', array($update, $close));
		$response->sendResponse();	
		
		return true;
	}
	
	public function onPayplansUpdateCarDdata()
	{
		$cardNumber		= JFactory::getApplication()->input->get('card_number', false);
		$exp_month		= JFactory::getApplication()->input->get('exp_month', 	false);
		$exp_year		= JFactory::getApplication()->input->get('exp_year', 	false);
		$invoiceId		= JFactory::getApplication()->input->get('invoice_id', 	false);
		
	
		$args        = array($cardNumber, $exp_month, $exp_year, $invoiceId);
		$is_updated  = PayplansHelperEvent::trigger('onPayplansMesStoreCard', $args);
		
		$html 		 = $this->_render('update_error');
		if($is_updated['0'] == true){
	  		$html 		= $this->_render('update_success');
		}
	  	
		$title 		 = XiText::_('COM_PAYPLANS_APP_MES_UPDATE_CARD_DETAILS');
	  	$domObject   = 'xiWindowBody';
		$domProperty = 'innerHTML';

		$response	 = XiFactory::getAjaxResponse();
		$response->addAssign( $domObject , $domProperty , $html );
		$response->addScriptCall('xi.ui.dialog.title',$title);
		$response->addScriptCall('payplans.jQuery(\'#payplans-update-card\').hide');
		$response->sendResponse();
	}
	
}


